Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traldf.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traldf.F90	(revision 2023)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traldf.F90	(revision 2024)
@@ -4,5 +4,6 @@
    !! Ocean Active tracers : lateral diffusive trends 
    !!=====================================================================
-   !! History :  9.0  ! 05-11 (G. Madec)  Original code
+   !! History :  9.0  ! 2005-11 (G. Madec)  Original code
+   !!       NEMO 3.0  ! 2008-01  (C. Ethe, G. Madec)  merge TRC-TRA 
    !!----------------------------------------------------------------------
 
@@ -21,6 +22,6 @@
    USE traldf_iso      ! lateral mixing               (tra_ldf_iso routine)
    USE traldf_lap      ! lateral mixing               (tra_ldf_lap routine)
-   USE trdmod          ! ocean active tracers trends
-   USE trdmod_oce      ! ocean variables trends
+   USE trdmod_oce      ! ocean space and time domain
+   USE trdtra          ! ocean active tracers trends
    USE prtctl          ! Print control
    USE in_out_manager  ! I/O manager
@@ -31,8 +32,8 @@
    PRIVATE
 
-   PUBLIC   tra_ldf    ! called by step.F90 
-
-   INTEGER, PUBLIC ::   nldf = 0   ! type of lateral diffusion used defined from ln_traldf_... namlist logicals)
-                                   ! (need to be public to be used in vertical diffusion routine)
+   PUBLIC   tra_ldf         ! called by step.F90 
+   PUBLIC   tra_ldf_init    ! called by opa.F90 
+   !
+   INTEGER ::   nldf = 0   ! type of lateral diffusion used defined from ln_traldf_... namlist logicals)
 #if defined key_traldf_ano
    REAL, DIMENSION(jpi,jpj,jpk) ::   t0_ldf, s0_ldf   ! lateral diffusion trends of T & S
@@ -60,54 +61,65 @@
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
       !!
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrdt, ztrds   ! 3D temporary workspace
-      !!----------------------------------------------------------------------
-
-      IF( kt == nit000 )   CALL ldf_ctl          ! initialisation & control of options
-
-      IF( l_trdtra )   THEN                      ! temporary save of ta and sa trends
-         ztrdt(:,:,:) = ta(:,:,:) 
-         ztrds(:,:,:) = sa(:,:,:) 
-      ENDIF
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt, ztrds
+      REAL(wp), DIMENSION(jpi,jpj,jpts) :: zgtsu, zgtsv
+      !!----------------------------------------------------------------------
+
+      IF( l_trdtra )   THEN                    !* Save ta and sa trends
+         ALLOCATE( ztrdt(jpi,jpj,jpk) )   ;    ztrdt(:,:,:) = tsa(:,:,:,jp_tem) 
+         ALLOCATE( ztrds(jpi,jpj,jpk) )   ;    ztrds(:,:,:) = tsa(:,:,:,jp_sal)
+      ENDIF
+
+      zgtsu(:,:,jp_tem) = gtu(:,:)        ;        zgtsu(:,:,jp_sal) = gsu(:,:)
+      zgtsv(:,:,jp_tem) = gtv(:,:)        ;        zgtsv(:,:,jp_sal) = gsv(:,:)
 
       SELECT CASE ( nldf )                       ! compute lateral mixing trend and add it to the general trend
-      CASE ( 0 )   ;   CALL tra_ldf_lap   ( kt )      ! iso-level laplacian
-      CASE ( 1 )   ;   CALL tra_ldf_iso   ( kt )      ! rotated laplacian (except dk[ dk[.] ] part)
-      CASE ( 2 )   ;   CALL tra_ldf_bilap ( kt )      ! iso-level bilaplacian
-      CASE ( 3 )   ;   CALL tra_ldf_bilapg( kt )      ! s-coord. horizontal bilaplacian
+      CASE ( 0 )   ;   CALL tra_ldf_lap   ( kt , 'TRA', zgtsu, zgtsv,  &
+                       &                    tsb, tsa  , jpts           )   ! iso-level laplacian
+      CASE ( 1 )   ;   CALL tra_ldf_iso   ( kt , 'TRA', zgtsu, zgtsv,  &
+                       &                    tsb, tsa  , jpts , ahtb0   )   ! rotated laplacian 
+      CASE ( 2 )   ;   CALL tra_ldf_bilap ( kt , 'TRA', zgtsu, zgtsv,  &
+                       &                    tsb, tsa  , jpts           )   ! iso-level bilaplacian
+      CASE ( 3 )   ;   CALL tra_ldf_bilapg( kt , 'TRA', tsb, tsa, jpts )      ! s-coord. horizontal bilaplacian
          !
       CASE ( -1 )                                     ! esopa: test all possibility with control print
-         CALL tra_ldf_lap    ( kt )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf0 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_ldf_iso    ( kt )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf1 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_ldf_bilap  ( kt )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf2 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
-         CALL tra_ldf_bilapg ( kt )
-         CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf3 - Ta: ', mask1=tmask,               &
-            &          tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+                       CALL tra_ldf_lap   ( kt , 'TRA', zgtsu, zgtsv,  &
+                       &                    tsb, tsa  , jpts           ) 
+                       CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' ldf0 - Ta: ', mask1=tmask,               &
+                       &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+                       CALL tra_ldf_iso   ( kt , 'TRA', zgtsu, zgtsv,  &
+                       &                    tsb, tsa  , jpts , ahtb0   ) 
+                       CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' ldf1 - Ta: ', mask1=tmask,               &
+                       &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+                       CALL tra_ldf_bilap ( kt , 'TRA', zgtsu, zgtsv,  &
+                       &                    tsb, tsa  , jpts           ) 
+                       CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' ldf2 - Ta: ', mask1=tmask,               &
+                       &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+                       CALL tra_ldf_bilapg( kt , 'TRA', tsb, tsa, jpts ) 
+                       CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' ldf3 - Ta: ', mask1=tmask,               &
+                       &             tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
       END SELECT
 
 #if defined key_traldf_ano
-      ta(:,:,:) = ta(:,:,:) - t0_ldf(:,:,:)      ! anomaly: substract the reference diffusivity
-      sa(:,:,:) = sa(:,:,:) - s0_ldf(:,:,:)
+      tsa(:,:,:,jp_tem) = tsa(:,:,:,jp_tem) - t0_ldf(:,:,:)      ! anomaly: substract the reference diffusivity
+      tsa(:,:,:,jp_sal) = tsa(:,:,:,jp_sal) - s0_ldf(:,:,:)
 #endif
+
       IF( l_trdtra )   THEN                      ! save the horizontal diffusive trends for further diagnostics
-         ztrdt(:,:,:) = ta(:,:,:) - ztrdt(:,:,:)
-         ztrds(:,:,:) = sa(:,:,:) - ztrds(:,:,:)
-         CALL trd_mod( ztrdt, ztrds, jptra_trd_ldf, 'TRA', kt )
+         ztrdt(:,:,:) = tsa(:,:,:,jp_tem) - ztrdt(:,:,:)
+         ztrds(:,:,:) = tsa(:,:,:,jp_sal) - ztrds(:,:,:)
+         CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_ldf, ztrdt )
+         CALL trd_tra( kt, 'TRA', jp_sal, jptra_trd_ldf, ztrds )
+         DEALLOCATE( ztrdt )      ;     DEALLOCATE( ztrds ) 
       ENDIF
       !                                          ! print mean trends (used for debugging)
-      IF(ln_ctl)   CALL prt_ctl( tab3d_1=ta, clinfo1=' ldf  - Ta: ', mask1=tmask,               &
-         &                       tab3d_2=sa, clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
+      IF(ln_ctl)   CALL prt_ctl( tab3d_1=tsa(:,:,:,jp_tem), clinfo1=' ldf  - Ta: ', mask1=tmask,               &
+         &                       tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
       !
    END SUBROUTINE tra_ldf
 
 
-   SUBROUTINE ldf_ctl
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE ldf_ctl  ***
+   SUBROUTINE tra_ldf_init
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE tra_ldf_init  ***
       !! 
       !! ** Purpose :   Choice of the operator for the lateral tracer diffusion
@@ -135,5 +147,5 @@
       IF(lwp) THEN                    ! Namelist print
          WRITE(numout,*)
-         WRITE(numout,*) 'tra:ldf_ctl : lateral tracer diffusive operator'
+         WRITE(numout,*) 'tra_ldf_init : lateral tracer diffusive operator'
          WRITE(numout,*) '~~~~~~~~~~~'
          WRITE(numout,*) '   Namelist namtra_ldf : set lateral mixing parameters (type, direction, coefficients)'
@@ -225,5 +237,5 @@
       CALL ldf_ano
       !
-   END SUBROUTINE ldf_ctl
+   END SUBROUTINE tra_ldf_init
 
 #if defined key_traldf_ano
@@ -271,16 +283,16 @@
       t0_ldf(:,:,:) = 0.e0
       s0_ldf(:,:,:) = 0.e0
-      ztb   (:,:,:) = tb (:,:,:)
-      zsb   (:,:,:) = sb (:,:,:)
-      ua    (:,:,:) = ta (:,:,:)
-      va    (:,:,:) = sa (:,:,:)
+      ztb   (:,:,:) = tsb (:,:,:,jp_tem)
+      zsb   (:,:,:) = tsb (:,:,:,jp_sal)
+      ua    (:,:,:) = tsa (:,:,:,jp_tem)
+      va    (:,:,:) = tsa (:,:,:,jp_sal)
       zavt  (:,:,:) = avt(:,:,:)
       IF( lk_zdfddm ) THEN CALL ctl_stop( ' key_traldf_ano with key_zdfddm not implemented' )
       ! set tb, sb to reference values and avr to zero
-      tb (:,:,:) = zt_ref(:,:,:)
-      sb (:,:,:) = zs_ref(:,:,:)
-      ta (:,:,:) = 0.e0
-      sa (:,:,:) = 0.e0
-      avt(:,:,:) = 0.e0
+      tsb (:,:,:,jp_tem) = zt_ref(:,:,:)
+      tsb (:,:,:,jp_sal) = zs_ref(:,:,:)
+      tsa (:,:,:,jp_tem) = 0.e0
+      tsa (:,:,:,jp_sal) = 0.e0
+      avt(:,:,:)         = 0.e0
 
       ! Compute the ldf trends
@@ -295,17 +307,17 @@
       IF( neuler == 1)   z12 = 1.e0
       IF( ln_zdfexp ) THEN      ! ta,sa are the trends
-         t0_ldf(:,:,:) = ta(:,:,:)
-         s0_ldf(:,:,:) = sa(:,:,:)
+         t0_ldf(:,:,:) = tsa(:,:,:,jp_tem)
+         s0_ldf(:,:,:) = tsa(:,:,:,jp_sal)
       ELSE
          DO jk = 1, jpkm1
-            t0_ldf(:,:,jk) = ( ta(:,:,jk) - tb(:,:,jk) ) / ( z12 *rdttra(jk) )
-            s0_ldf(:,:,jk) = ( sa(:,:,jk) - tb(:,:,jk) ) / ( z12 *rdttra(jk) )
+            t0_ldf(:,:,jk) = ( tsa(:,:,jk,jp_tem) - tsb(:,:,jk,jp_tem) ) / ( z12 *rdttra(jk) )
+            s0_ldf(:,:,jk) = ( tsa(:,:,jk,jp_sal) - tsb(:,:,jk,jp_sal) ) / ( z12 *rdttra(jk) )
          END DO
       ENDIF
-      tb    (:,:,:) = ztb (:,:,:)
-      sb    (:,:,:) = zsb (:,:,:)
-      ta    (:,:,:) = ua  (:,:,:)
-      sa    (:,:,:) = va  (:,:,:)
-      avt   (:,:,:) = zavt(:,:,:)
+      tsb(:,:,:,jp_tem) = ztb (:,:,:)
+      tsb(:,:,:,jp_sal) = zsb (:,:,:)
+      tsa(:,:,:,jp_tem) = ua  (:,:,:)
+      tsa(:,:,:,jp_sal) = va  (:,:,:)
+      avt(:,:,:)        = zavt(:,:,:)
       !
    END SUBROUTINE ldf_ano
Index: /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traldf_bilap.F90
===================================================================
--- /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traldf_bilap.F90	(revision 2023)
+++ /branches/DEV_r2006_merge_TRA_TRC/NEMO/OPA_SRC/TRA/traldf_bilap.F90	(revision 2024)
@@ -2,5 +2,16 @@
    !!==============================================================================
    !!                   ***  MODULE  traldf_bilap  ***
-   !! Ocean active tracers:  horizontal component of the lateral tracer mixing trend
+   !! Ocean  tracers:  horizontal component of the lateral tracer mixing trend
+   !!==============================================================================
+   !! History :     !  91-11  (G. Madec)  Original code
+   !!               !  93-03  (M. Guyon)  symetrical conditions
+   !!               !  95-11  (G. Madec)  suppress volumetric scale factors
+   !!               !  96-01  (G. Madec)  statement function for e3
+   !!               !  96-01  (M. Imbard)  mpp exchange
+   !!               !  97-07  (G. Madec)  optimization, and ahtt
+   !!          8.5  !  02-08  (G. Madec)  F90: Free form and module
+   !!          9.0  !  04-08  (C. Talandier) New trends organization
+   !!               !  05-11  (G. Madec)  zps or sco as default option
+   !!          3.3  !  10-05  (C. Ethe, G. Madec)  merge TRC-TRA 
    !!==============================================================================
 
@@ -13,11 +24,8 @@
    USE dom_oce         ! ocean space and time domain
    USE ldftra_oce      ! ocean tracer   lateral physics
-   USE trdmod          ! ocean active tracers trends 
-   USE trdmod_oce      ! ocean variables trends
    USE in_out_manager  ! I/O manager
    USE ldfslp          ! iso-neutral slopes 
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE diaptr          ! poleward transport diagnostics
-   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -39,15 +47,16 @@
 
 CONTAINS
-   
-   SUBROUTINE tra_ldf_bilap( kt )
+ 
+   SUBROUTINE tra_ldf_bilap( kt   , cdtype, pgtu, pgtv,  &
+      &                      ptrab, ptraa , kjpt         )  
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE tra_ldf_bilap  ***
       !!
-      !! ** Purpose :   Compute the before horizontal tracer (t & s) diffusive 
+      !! ** Purpose :   Compute the before horizontal tracer diffusive 
       !!      trend and add it to the general trend of tracer equation.
       !!
       !! ** Method  :   4th order diffusive operator along model level surfaces 
       !!      evaluated using before fields (forward time scheme). The hor.
-      !!      diffusive trends of temperature (idem for salinity) is given by:
+      !!      diffusive trends  is given by:
       !!      Laplacian of tb:
       !!         zlt   = 1/(e1t*e2t*e3t) {  di-1[ e2u*e3u/e1u di(tb) ]
@@ -59,39 +68,27 @@
       !!         difft = 1/(e1t*e2t*e3t) {  di-1[ e2u*e3u/e1u di(zlt) ]
       !!                                  + dj-1[ e1v*e3v/e2v dj(zlt) ]  }
-      !!      Note: if key_zco defined, e3t=e3u=e3v, they are simplified.
       !!
-      !!      Add this trend to the general trend (ta,sa):
-      !!         (ta,sa) = (ta,sa) + ( difft , diffs )
+      !!      Add this trend to the general trend
+      !!         (ptraa) = (ptraa) + ( difft )
       !!
-      !! ** Action : - Update (ta,sa) arrays with the before iso-level
+      !! ** Action : - Update ptraa arrays with the before iso-level
       !!               biharmonic mixing trend.
-      !!
-      !! History :
-      !!        !  91-11  (G. Madec)  Original code
-      !!        !  93-03  (M. Guyon)  symetrical conditions
-      !!        !  95-11  (G. Madec)  suppress volumetric scale factors
-      !!        !  96-01  (G. Madec)  statement function for e3
-      !!        !  96-01  (M. Imbard)  mpp exchange
-      !!        !  97-07  (G. Madec)  optimization, and ahtt
-      !!   8.5  !  02-08  (G. Madec)  F90: Free form and module
-      !!   9.0  !  04-08  (C. Talandier) New trends organization
-      !!        !  05-11  (G. Madec)  zps or sco as default option
       !!----------------------------------------------------------------------
-      !! * Modules used
-      USE oce           , ztu => ua,  &  ! use ua as workspace
-         &                ztv => va      ! use va as workspace
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt       ! ocean time-step index
-
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk             ! dummy loop indices
-      INTEGER ::   iku, ikv               ! temporary integers
-      REAL(wp) ::   zta, zsa              ! temporary scalars
+      !!* Module used
+      USE oce         , ztu => ua   ! use ua as workspace
+      USE oce         , ztv => va   ! use va as workspace
+      !!* Arguments
+      INTEGER         , INTENT(in   )                                ::   kt             ! ocean time-step index
+      CHARACTER(len=3), INTENT(in   )                                ::   cdtype         ! =TRA or TRC (tracer indicator)
+      INTEGER         , INTENT(in   )                                ::   kjpt            ! number of tracers
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,kjpt  )     ::   pgtu, pgtv     ! tracer gradient at pstep levels
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,jpk,kjpt)   ::   ptrab          ! before and now tracer fields
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk,kjpt)   ::   ptraa          ! tracer trend 
+      !!* Local declarations
+      INTEGER  ::  ji, jj, jk, jn         ! dummy loop indices
+      INTEGER  ::  iku, ikv               ! temporary integers
+      REAL(wp) ::  zbtr, ztra             ! temporary scalars
       REAL(wp), DIMENSION(jpi,jpj) ::   & 
-         zeeu, zeev, zbtr,              & ! 2D workspace
-         zlt, zls
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   & 
-         zsu, zsv                         ! 3D workspace 
+         zeeu, zeev, zlt               ! 2D workspace
       !!----------------------------------------------------------------------
 
@@ -101,124 +98,86 @@
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~'
       ENDIF
-
-
-      !                                                ! ===============
-      DO jk = 1, jpkm1                                 ! Horizontal slab
-         !                                             ! ===============
-
-         ! 0. Initialization of metric arrays (for z- or s-coordinates)
-         ! ----------------------------------
-
-         IF( lk_zco ) THEN      ! z-coordinate (1D arrays): no vertical scale factors
+      !                                                          ! ===========
+      DO jn = 1, kjpt                                            ! tracer loop
+         !                                                       ! ===========
+         !                                               
+         DO jk = 1, jpkm1                                 
+            !                                             
+            
+            ! 0. Initialization of metric arrays (for z- or s-coordinates)
+            ! ----------------------------------
             DO jj = 1, jpjm1
                DO ji = 1, fs_jpim1   ! vector opt.
-                  zbtr(ji,jj) = 1. / ( e1t(ji,jj)*e2t(ji,jj) )
-                  zeeu(ji,jj) = e2u(ji,jj) / e1u(ji,jj) * umask(ji,jj,jk)
-                  zeev(ji,jj) = e1v(ji,jj) / e2v(ji,jj) * vmask(ji,jj,jk)
-               END DO
-            END DO
-         ELSE                   ! All coordinates (3D arrays): vertical scale factor are used
-            DO jj = 1, jpjm1
-               DO ji = 1, fs_jpim1   ! vector opt.
-                  zbtr(ji,jj) = 1. / ( e1t(ji,jj)*e2t(ji,jj)*fse3t(ji,jj,jk) )
                   zeeu(ji,jj) = e2u(ji,jj) * fse3u(ji,jj,jk) / e1u(ji,jj) * umask(ji,jj,jk)
                   zeev(ji,jj) = e1v(ji,jj) * fse3v(ji,jj,jk) / e2v(ji,jj) * vmask(ji,jj,jk)
                END DO
             END DO
-         ENDIF
 
 
-         ! 1. Laplacian
-         ! ------------
-
-         ! First derivative (gradient)
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-               ztu(ji,jj,jk) = zeeu(ji,jj) * ( tb(ji+1,jj  ,jk) - tb(ji,jj,jk) )
-               zsu(ji,jj,jk) = zeeu(ji,jj) * ( sb(ji+1,jj  ,jk) - sb(ji,jj,jk) )
-               ztv(ji,jj,jk) = zeev(ji,jj) * ( tb(ji  ,jj+1,jk) - tb(ji,jj,jk) )
-               zsv(ji,jj,jk) = zeev(ji,jj) * ( sb(ji  ,jj+1,jk) - sb(ji,jj,jk) )
-            END DO
-         END DO
-         IF( ln_zps ) THEN      ! set gradient at partial step level
+            ! 1. Laplacian
+            ! ------------
+            
+            ! First derivative (gradient)
             DO jj = 1, jpjm1
-               DO ji = 1, jpim1
-                  ! last level
-                  iku = MIN ( mbathy(ji,jj), mbathy(ji+1,jj  ) ) - 1
-                  ikv = MIN ( mbathy(ji,jj), mbathy(ji  ,jj+1) ) - 1
-                  IF( iku == jk ) THEN
-                     ztu(ji,jj,jk) = zeeu(ji,jj) * gtu(ji,jj)
-                     zsu(ji,jj,jk) = zeeu(ji,jj) * gsu(ji,jj)
-                  ENDIF
-                  IF( ikv == jk ) THEN
-                     ztv(ji,jj,jk) = zeev(ji,jj) * gtv(ji,jj)
-                     zsv(ji,jj,jk) = zeev(ji,jj) * gsv(ji,jj)
-                  ENDIF
+               DO ji = 1, fs_jpim1   ! vector opt.
+                  ztu(ji,jj,jk) = zeeu(ji,jj) * ( ptrab(ji+1,jj  ,jk,jn) - ptrab(ji,jj,jk,jn) )
+                  ztv(ji,jj,jk) = zeev(ji,jj) * ( ptrab(ji  ,jj+1,jk,jn) - ptrab(ji,jj,jk,jn) )
                END DO
             END DO
-         ENDIF
-
-         ! Second derivative (divergence)
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zlt(ji,jj) = zbtr(ji,jj) * (  ztu(ji,jj,jk) - ztu(ji-1,jj,jk) + ztv(ji,jj,jk) - ztv(ji,jj-1,jk)  )
-               zls(ji,jj) = zbtr(ji,jj) * (  zsu(ji,jj,jk) - zsu(ji-1,jj,jk) + zsv(ji,jj,jk) - zsv(ji,jj-1,jk)  )
-            END DO
-         END DO
-
-         ! Multiply by the eddy diffusivity coefficient
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zlt(ji,jj) = fsahtt(ji,jj,jk) * zlt(ji,jj)
-               zls(ji,jj) = fsahtt(ji,jj,jk) * zls(ji,jj)
-            END DO
-         END DO
-
-         ! Lateral boundary conditions on the laplacian (zlt,zls)   (unchanged sgn)
-         CALL lbc_lnk( zlt, 'T', 1. )   ;    CALL lbc_lnk( zls, 'T', 1. )
-
-         ! 2. Bilaplacian
-         ! --------------
-
-         ! third derivative (gradient)
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-               ztu(ji,jj,jk) = zeeu(ji,jj) * ( zlt(ji+1,jj  ) - zlt(ji,jj) )
-               zsu(ji,jj,jk) = zeeu(ji,jj) * ( zls(ji+1,jj  ) - zls(ji,jj) )
-               ztv(ji,jj,jk) = zeev(ji,jj) * ( zlt(ji  ,jj+1) - zlt(ji,jj) )
-               zsv(ji,jj,jk) = zeev(ji,jj) * ( zls(ji  ,jj+1) - zls(ji,jj) )
-            END DO
-         END DO
-
-         ! fourth derivative (divergence) and add to the general tracer trend
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               ! horizontal diffusive trends
-               zta = zbtr(ji,jj) * (  ztu(ji,jj,jk) - ztu(ji-1,jj,jk) + ztv(ji,jj,jk) - ztv(ji,jj-1,jk)  )
-               zsa = zbtr(ji,jj) * (  zsu(ji,jj,jk) - zsu(ji-1,jj,jk) + zsv(ji,jj,jk) - zsv(ji,jj-1,jk)  )
-               ! add it to the general tracer trends
-               ta(ji,jj,jk) = ta(ji,jj,jk) + zta
-               sa(ji,jj,jk) = sa(ji,jj,jk) + zsa
-            END DO
-         END DO
-         !                                             ! ===============
-      END DO                                           ! Horizontal slab
-      !                                                ! ===============
-
-      ! "zonal" mean lateral diffusive heat and salt transport
-      IF( ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
-         IF( lk_zco ) THEN      ! z-coordinate (1D arrays): multiply by the vertical scale factor
-            DO jk = 1, jpkm1
-               DO jj = 2, jpjm1
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
-                     ztv(ji,jj,jk) = ztv(ji,jj,jk) * fse3v(ji,jj,jk)
-                     zsv(ji,jj,jk) = zsv(ji,jj,jk) * fse3v(ji,jj,jk)
+            IF( ln_zps ) THEN      ! set gradient at partial step level
+               DO jj = 1, jpjm1
+                  DO ji = 1, jpim1
+                     ! last level
+                     iku = MIN ( mbathy(ji,jj), mbathy(ji+1,jj  ) ) - 1
+                     ikv = MIN ( mbathy(ji,jj), mbathy(ji  ,jj+1) ) - 1
+                     IF( iku == jk )  ztu(ji,jj,jk) = zeeu(ji,jj) * pgtu(ji,jj,jn)
+                     IF( ikv == jk )  ztv(ji,jj,jk) = zeev(ji,jj) * pgtv(ji,jj,jn)
                   END DO
                END DO
+            ENDIF
+
+            ! Second derivative (divergence) multiply by the eddy diffusivity coefficient
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  zbtr = 1.0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                  zlt(ji,jj) = fsahtt(ji,jj,jk) &
+                     &                * zbtr * (  ztu(ji,jj,jk) - ztu(ji-1,jj,jk) + ztv(ji,jj,jk) - ztv(ji,jj-1,jk)  )
+               END DO
             END DO
+
+            ! Lateral boundary conditions on the laplacian (zlt)   (unchanged sgn)
+            CALL lbc_lnk( zlt, 'T', 1. )
+
+            ! 2. Bilaplacian
+            ! --------------
+            
+            ! third derivative (gradient)
+            DO jj = 1, jpjm1
+               DO ji = 1, fs_jpim1   ! vector opt.
+                  ztu(ji,jj,jk) = zeeu(ji,jj) * ( zlt(ji+1,jj  ) - zlt(ji,jj) )
+                  ztv(ji,jj,jk) = zeev(ji,jj) * ( zlt(ji  ,jj+1) - zlt(ji,jj) )
+               END DO
+            END DO
+
+            ! fourth derivative (divergence) and add to the general tracer trend
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  ! horizontal diffusive trends
+                  zbtr = 1.0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                  ztra = zbtr * (  ztu(ji,jj,jk) - ztu(ji-1,jj,jk) + ztv(ji,jj,jk) - ztv(ji,jj-1,jk)  )
+                  ! add it to the general tracer trends
+                  ptraa(ji,jj,jk,jn) = ptraa(ji,jj,jk,jn) + ztra
+               END DO
+            END DO
+            !                                             ! ===============
+         END DO                                           ! Horizontal slab
+         !                                                ! ===============
+         ! "zonal" mean lateral diffusive heat and salt transport
+         IF( cdtype == 'TRA' .AND. ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN  
+           IF( jn == jp_tem )  pht_ldf(:) = ptr_vj( ztv(:,:,:) )
+           IF( jn == jp_sal )  pst_ldf(:) = ptr_vj( ztv(:,:,:) )
          ENDIF
-         pht_ldf(:) = ptr_vj( ztv(:,:,:) )
-         pst_ldf(:) = ptr_vj( zsv(:,:,:) )
-      ENDIF
+         !
+      END DO
 
    END SUBROUTINE tra_ldf_bilap
